# -*- coding: utf-8 -*-
from setuphelpers import *
import json

def update_package():
    # Initializing variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    url = "https://anydesk.com/downloads/linux"

    # Getting latest version from official sources
    print("URL used is: %s" % url)
    for bs_search in bs_find_all(url, "script", proxies=proxies):
        raw_json = bs_search.string
        if raw_json and "{var downloads=" in ensure_unicode(raw_json):
            json_load = json.loads(raw_json.split("{var downloads=")[-1].split(';$("#iconNav .nav-link")')[0])

    for download in json_load["linux"]["packages"]:
        if download["id"] == "deb_64":
            version = download["version"]
            download_url = download["url"]
            latest_bin = download_url.split("/")[-1]

    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating or not update-package-sources
    return result
